datablock AudioProfile(Wolf3dSoundAmmoPickup)
{
      filename = "./pickup_ammo.wav";
      description = AudioClosest3d;
      preload = false;
};

datablock AudioProfile(Wolf3dSoundAmmoPickupLarge)
{
      filename = "./pickup_ammo_large.wav";
      description = AudioClosest3d;
      preload = false;
};

datablock ItemData(Wolf3dAmmoSmall)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./ammo.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = true;
	uiName = "Small Clip";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	ammocount = 4;
	ammotype = "ammo";
	fullName = "Ammo";
	isLarge = 0;
	isAmmo = 1;
};

datablock ItemData(Wolf3dAmmoNormal : Wolf3dAmmoSmall)
{
	shapeFile = "./ammo.dts";
	uiName = "Normal Clip";
	ammocount = 8;
	ammotype = "ammo";
	fullName = "Ammo";
	isLarge = 0;
	isAmmo = 1;
};

datablock ItemData(Wolf3dAmmoLarge : Wolf3dAmmoSmall)
{
	shapeFile = "./ammobox.dts";
	uiName = "Ammo Box";
	ammocount = 25;
	ammotype = "ammo";
	fullName = "Ammo";
	isAmmo = 1;
	isLarge = 1;
};

datablock ItemData(Wolf3dAmmoFuel : Wolf3dAmmoSmall)
{
	shapeFile = "./fuel.dts";
	uiName = "Fuel";
	ammocount = 14;
	ammotype = "fuel";
	fullName = "Fuel";
	isLarge = 0;
	isAmmo = 1;
};

datablock ItemData(Wolf3dAmmoRocket : Wolf3dAmmoSmall)
{
	shapeFile = "./rocketcrate.dts";
	uiName = "Rocket Crate";
	ammocount = 5;
	ammotype = "rocket";
	fullName = "Rocket";
	isLarge = 0;
	isAmmo = 1;
};

function Wolf3dAmmoSmall::onAdd(%this, %obj)
{
	if(%obj.ammocount == 0)
	{
	%obj.ammocount = %obj.getdatablock().ammocount;
	%obj.ammotype = %obj.getdatablock().ammotype;
	%obj.fullName = %obj.getdatablock().fullName;
	%obj.isLarge = %obj.getdatablock().isLarge;
	%obj.isAmmo = %obj.getdatablock().isAmmo;
	}
	%obj.rotate = true;
	//%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

function Wolf3dAmmoNormal::onAdd(%this, %obj)
{
	if(%obj.ammocount == 0)
	{
		%obj.ammocount = %obj.getdatablock().ammocount;
		%obj.ammotype = %obj.getdatablock().ammotype;
		%obj.fullName = %obj.getdatablock().fullName;
		%obj.isLarge = %obj.getdatablock().isLarge;
		%obj.isAmmo = %obj.getdatablock().isAmmo;
	}
	%obj.rotate = true;
	//%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

function Wolf3dAmmoLarge::onAdd(%this, %obj)
{
	if(%obj.ammocount == 0)
	{
		%obj.ammocount = %obj.getdatablock().ammocount;
		%obj.ammotype = %obj.getdatablock().ammotype;
		%obj.fullName = %obj.getdatablock().fullName;
		%obj.isLarge = %obj.getdatablock().isLarge;
		%obj.isAmmo = %obj.getdatablock().isAmmo;
	}
	%obj.rotate = false;
	//%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

function Wolf3dAmmoFuel::onAdd(%this, %obj)
{
	if(%obj.ammocount == 0)
	{
		%obj.ammocount = %obj.getdatablock().ammocount;
		%obj.ammotype = %obj.getdatablock().ammotype;
		%obj.fullName = %obj.getdatablock().fullName;
		%obj.isLarge = %obj.getdatablock().isLarge;
		%obj.isAmmo = %obj.getdatablock().isAmmo;
	}
	%obj.rotate = false;
	//%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

function Wolf3dAmmoRocket::onAdd(%this, %obj)
{
	if(%obj.ammocount == 0)
	{
		%obj.ammocount = %obj.getdatablock().ammocount;
		%obj.ammotype = %obj.getdatablock().ammotype;
		%obj.fullName = %obj.getdatablock().fullName;
		%obj.isLarge = %obj.getdatablock().isLarge;
		%obj.isAmmo = %obj.getdatablock().isAmmo;
	}
	%obj.rotate = false;
	//%obj.setShapeName(%obj.ammocount);
	Parent::onAdd(%this, %obj);
}

package PackageAmmoBasic
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(isObject(%obj.client) && %col.canPickup && %obj.getDamagePercent() < 1.0 && minigameCanUse(%obj.client, %col) && %col.isAmmo == 1)
		{
			//echo(%col.isAmmo SPC %col.ammotype SPC %col.ammocount);
			if (%obj.getClassName() !$= "Player" || %obj.toolAmmo["wolf3d_" @ %col.ammotype] >= 99)
				return;
			%obj.toolAmmo["wolf3d_" @ %col.ammotype] += %col.ammocount;
			if(%obj.toolAmmo["wolf3d_" @ %col.ammotype] > 99)
			{
				%obj.toolAmmo["wolf3d_" @ %col.ammotype] = 99;
			}
			if (%col.isLarge == "1")
				serverPlay3D(Wolf3dSoundAmmoPickupLarge,%obj.getPosition());
			else
				serverPlay3D(Wolf3dSoundAmmoPickup,%obj.getPosition());

			if(isObject(%col.spawnbrick))
			{
				%col.fadeOut();
				%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}
			else
			{
				%col.schedule(10, delete);
			}
			%this.onPickup(%obj, %player);
			if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
			else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>" @ %col.fullName @ ":  \c6" @  %obj.toolAmmo["wolf3d_" @ %col.ammotype] @ "", 4, 2, 3, 4);
			commandToClient(%obj.client,'centerPrint',"<just:right><font:impact:24><color:FFFFFF>+"@  %col.ammocount @ "<color:00FBFF> " @ %col.fullName @ "", 2, 2, 3, 4); 
			
			return;
		}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(PackageAmmoBasic);