datablock AudioProfile(Wolf3dSoundOneUp)
{
      filename = "./pickup_oneup.wav";
      description = AudioClosest3d;
      preload = false;
};

datablock AudioProfile(Wolf3dSoundMedkit : Wolf3dSoundOneUp)
{
      filename = "./pickup_medkit.wav";
      description = AudioClosest3d;
      preload = false;
};

datablock AudioProfile(Wolf3dSoundFood)
{
      filename = "./pickup_food.wav";
      description = AudioClosest3d;
      preload = false;
};


datablock ItemData(Wolf3dHealthOneUp)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./oneup.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = true;
	uiName = "One Up";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	healingPower = "OneUp"; //100;
	isHealth = 1;
	sound = Wolf3dSoundOneUp;
};

datablock ItemData(Wolf3dHealthMedkit : Wolf3dHealthOneUp)
{
	shapeFile = "./medkit.dts";
	uiName = "First-Aid Kit";
	healingPower = "Medkit"; //25;
	isHealth = 1;
	sound = Wolf3dSoundMedkit;
};

datablock ItemData(Wolf3dHealthFood : Wolf3dHealthOneUp)
{
	shapeFile = "./food.dts";
	uiName = "Food Bowl";
	healingPower = "Food"; //10;
	isHealth = 1;
	sound = Wolf3dSoundFood;
};

datablock ItemData(Wolf3dHealthDogFood : Wolf3dHealthOneUp)
{
	shapeFile = "./dogfood.dts";
	uiName = "Dog Food";
	healingPower = "Dog"; //4;
	isHealth = 1;
	sound = Wolf3dSoundFood;
};

function Wolf3dHealthOneUp::onAdd(%this, %obj)
{
	if(%obj.healingPower == 0)
	{
		%obj.healingPower = %obj.getdatablock().healingPower;
		%obj.isHealth = %obj.getdatablock().isHealth;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
		%obj.special = true;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dHealthMedkit::onAdd(%this, %obj)
{
	if(%obj.healingPower == 0)
	{
		%obj.healingPower = %obj.getdatablock().healingPower;
		%obj.isHealth = %obj.getdatablock().isHealth;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dHealthFood::onAdd(%this, %obj)
{
	if(%obj.healingPower == 0)
	{
		%obj.healingPower = %obj.getdatablock().healingPower;
		%obj.isHealth = %obj.getdatablock().isHealth;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dHealthDogFood::onAdd(%this, %obj)
{
	if(%obj.healingPower == 0)
	{
		%obj.healingPower = %obj.getdatablock().healingPower;
		%obj.isHealth = %obj.getdatablock().isHealth;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

package PackageHealthBasic
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(isObject(%obj.client) && %col.canPickup && %obj.getDamagePercent() < 1.0 && minigameCanUse(%obj.client, %col) && %col.isHealth == 1)
		{
			if (%obj.getDamagePercent() <= 0 && !%col.special)
				return;
			
			%healing = $Pref::wolf3d::health_[%col.healingPower];
			%obj.addHealth(%healing);

			if (%col.special == true)
			{
				%obj.toolAmmo["wolf3d_ammo"] += 25;
				if(%obj.toolAmmo["wolf3d_ammo"] > 99)
					%obj.toolAmmo["wolf3d_ammo"] = 99;
				
				if (!$Pref::wolf3d::infiniteAmmo)
				{
					if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
					else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
					commandToClient(%obj.client,'centerPrint',"<just:right><font:impact:24><color:FFFFFF>+"@  %healing @ "<color:FC5A5A> Health  <color:FFFFFF>+25 <color:00FBFF> Ammo", 2, 2, 3, 4); 
				}
			}
			else
				commandToClient(%obj.client,'centerPrint',"<just:right><font:impact:24><color:FFFFFF>+"@  %healing @ "<color:FC5A5A> Health", 2, 2, 3, 4); 
			
			serverPlay3D(%col.sound,%obj.getPosition());

			if(isObject(%col.spawnbrick))
			{
				%col.fadeOut();
				%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}
			else
				%col.schedule(10, delete);
					
			%this.onPickup(%obj, %player);
			
			return;
		}
		
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(PackageHealthBasic);