datablock AudioProfile(Wolf3dSoundCross)
{
      filename = "./pickup_cross.wav";
      description = AudioClosest3d;
      preload = false;
};

datablock AudioProfile(Wolf3dSoundChalice : Wolf3dSoundCross)
{
      filename = "./pickup_chalice.wav";
};

datablock AudioProfile(Wolf3dSoundChest : Wolf3dSoundCross)
{
      filename = "./pickup_chest.wav";
};

datablock AudioProfile(Wolf3dSoundCrown : Wolf3dSoundCross)
{
      filename = "./pickup_crown.wav";
};


datablock ItemData(Wolf3dScoreCross)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./cross.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	rotate = true;
	uiName = "Cross";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;
	points = "Cross"; //1;
	sound = Wolf3dSoundCross;
};


datablock ItemData(Wolf3dScoreChalice : Wolf3dScoreCross)
{
	shapeFile = "./chalice.dts";
	uiName = "Chalice";
	points = "Chalice"; //5;
	sound = Wolf3dSoundChalice;
};


datablock ItemData(Wolf3dScoreChest : Wolf3dScoreCross)
{
	shapeFile = "./chest.dts";
	uiName = "Treasure Chest";
	points = "Chest"; //10;
	sound = Wolf3dSoundChest;
};


datablock ItemData(Wolf3dScoreCrown : Wolf3dScoreCross)
{
	shapeFile = "./crown.dts";
	uiName = "Studded Crown";
	points = "Crown"; //50;
	sound = Wolf3dSoundCrown;
};

function Wolf3dScoreCross::onAdd(%this, %obj)
{
	if(%obj.points == 0)
	{
		%obj.points = %obj.getdatablock().points;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dScoreChalice::onAdd(%this, %obj)
{
	if(%obj.points == 0)
	{
		%obj.points = %obj.getdatablock().points;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dScoreChest::onAdd(%this, %obj)
{
	if(%obj.points == 0)
	{
		%obj.points = %obj.getdatablock().points;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}

function Wolf3dScoreCrown::onAdd(%this, %obj)
{
	if(%obj.points == 0)
	{
		%obj.points = %obj.getdatablock().points;
		%obj.rotate = %obj.getdatablock().rotate;
		%obj.sound = %obj.getdatablock().sound;
	}
	Parent::onAdd(%this, %obj);
}
	
package PackageScoreBasic
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(isObject(%obj.client) && %col.canPickup && %obj.getDamagePercent() < 1.0 && minigameCanUse(%obj.client, %col) && %col.points !$= "")
		{
			%reward = $Pref::wolf3d::score_[%col.points];
			%obj.client.setScore(%obj.client.score + %reward);
			commandToClient(%obj.client,'centerPrint',"<just:right><font:impact:24><color:FFFFFF>+"@ %reward @ "<color:FFFF00> Score", 2, 2, 3, 4);
			serverPlay3D(%col.sound,%obj.getPosition());

			if(isObject(%col.spawnbrick))
			{
				%col.fadeOut();
				%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
			}
			else
				%col.schedule(10, delete);
			
			%this.onPickup(%obj, %player);
		
			return;
		}
		
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(PackageScoreBasic);