datablock ShapeBaseImageData(Wolf3dPistolGunLeftHandImage : Wolf3dPistolGunImage) { mountPoint = 1; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dPistolGunLeftHandImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
			
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
		
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, shiftAway);

		%spread = 0.000115;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

datablock ItemData(Wolf3dPistolGunChestMountItem : GunItem)
{
   shapeFile       = "./luger.dts";
   uiName          = "Pistol (Mounted)";
   iconName        = "";
   doColorShift    = false;
   rotate = true;
   colorShiftColor = "0.5 0.5 0.5 1";

   image   = Wolf3dPistolGunChestMountImage;
   canDrop   = true;
};
datablock ShapeBaseImageData(Wolf3dPistolGunChestMountImage : Wolf3dPistolGunImage) { offset = "-0.5 -0.5 -0.3"; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dPistolGunChestMountImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
			
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
		
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, shiftAway);

		%spread = 0.000115;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

function Wolf3dPistolGunChestMountImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if ($wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
	else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	%obj.playThread(2,armReady);
}

datablock ShapeBaseImageData(Wolf3dMachineGunLeftHandImage : Wolf3dMachineGunImage) { mountPoint = 1; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dMachineGunLeftHandImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, plant);

		%spread = 0.00076;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			initalPlayerPos = %obj.position;
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

function Wolf3dMachineGunLeftHandImage::checkAmmo(%this,%obj,%slot)
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

datablock ShapeBaseImageData(Wolf3dChainGunLeftHandImage : Wolf3dChainGunImage) { mountPoint = 1; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dChainGunLeftHandImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, plant);

		%spread = 0.00175;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
	
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Wolf3dChainGunLeftHandImage::checkAmmo(%this,%obj,%slot)	
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

datablock ShapeBaseImageData(Wolf3dFlameThrowerLeftHandImage : Wolf3dFlameThrowerImage) { mountPoint = 1; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dFlameThrowerLeftHandImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
	
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_fuel"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_fuel"]--;

		%spread = 0.0005; //.1 = 180 degrees
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Fuel:  \c6" @  %obj.toolAmmo["wolf3d_fuel"] @ "", 4, 2, 3, 4); 
	}
	
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_fuel"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

datablock ShapeBaseImageData(Wolf3dRocketLLeftHandImage : Wolf3dRocketLImage) { mountPoint = 1; wolf3d_lefthand = true; eyeOffset = 0; };
function Wolf3dRocketLLeftHandImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_rocket"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		%obj.toolAmmo["wolf3d_rocket"]--;
		
		%obj.playThread(2, shiftAway);

		%spread = 0.0;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Rocket:  \c6" @  %obj.toolAmmo["wolf3d_rocket"] @ "", 4, 2, 3, 4);
	}
}