////////////
//ChainGun//
////////////

datablock AudioProfile(Wolf3dChainGunSound)
{
   filename    = "./cg_fire.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("Wolf3dChainGunKill", '<bitmap:Add-Ons/Weapon_Wolf3d/CI_Chaingun> %1', '%2 <bitmap:Add-Ons/Weapon_Wolf3d/CI_Chaingun> %1',0.2,1);

datablock ItemData(Wolf3dChainGunItem : GunItem)
{
   shapeFile       = "./chaingun.dts";
   uiName          = "Wolf3d Chaingun"; //We are going to add wolf3d so it does not conflict with other similarly named items.
   iconName        = "./Icon_Chaingun";
   doColorShift    = false;
   rotate = true;
   colorShiftColor = "0 1 1 1";

   image   = Wolf3dChainGunImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(Wolf3dChainGunImage)
{
	// Basic Item properties
   shapeFile = "./chaingun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.02 0.3 -1.25"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dChaingunGunItem;
   ammo = "";
   projectile = Wolf3dGunProjectile;
   projectileType = Projectile;
   damageType = $DamageType::Wolf3dChainGunKill;

	casing 				= gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
	
   doColorShift    = Wolf3dChainGunItem.doColorShift;
   colorShiftColor = Wolf3dChainGunItem.colorShiftColor;

	stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Prime";
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";
   
	stateName[2]				= "Prime";
	stateScript[2]				= "checkAmmo";
	stateTimeoutValue[2]			= 0.2;
	stateTransitionOnTriggerUp[2]  = "Ready";
	stateTransitionOnTimeout[2]		= "PrimeCheck";
	stateSequence[2]               = "Fire";
	
	stateName[3]				= "PrimeCheck";
	stateTransitionOnAmmo[3]		= "Fire";
	stateTransitionOnNoAmmo[3]		= "ReloadWait";

   stateName[4]                   = "Fire";
   stateTransitionOnTimeout[4]    = "Prime2Check";
   stateTimeoutValue[4]           = 0.056;
   stateFire[4]                   = true;
   stateAllowImageChange[4]       = false;
   stateSequence[4]               = "Fire";
   stateScript[4]                 = "onFire";
   stateWaitForTimeout[4]         = true;
   stateEmitter[4]                = gunFlashEmitter;
   stateEmitterTime[4]            = 0.05;
   stateEmitterNode[4]            = "muzzleNode";
   stateSound[4]                  = Wolf3dChainGunSound;
   stateEjectShell[4]             = true;
   
   	//stateName[8]				= "Prime2";
	//stateScript[8]				= "checkAmmo";
	//stateTimeoutValue[8]			= 0.005;
	//stateTransitionOnTimeout[8]		= "Prime2Check";
	
	stateName[9]				= "Prime2Check";
	stateTransitionOnAmmo[9]		= "Fire2";
	stateTransitionOnNoAmmo[9]		= "ReloadWait";
   
   stateName[5]                   = "Fire2";
   stateTransitionOnTimeout[5]    = "Reload";
   stateTimeoutValue[5]           = 0.076;
   stateFire[5]                   = true;
   stateAllowImageChange[5]       = false;
   stateSequence[5]               = "Fire";
   stateScript[5]                 = "onFire";
   stateWaitForTimeout[5]         = true;
   stateEmitter[5]                = gunFlashEmitter;
   stateEmitterTime[5]            = 0.05;
   stateEmitterNode[5]            = "muzzleNode";
   stateSound[5]                  = Wolf3dChainGunSound;
   stateEjectShell[5]             = true;

   stateName[6]                   = "Smoke";
   stateEmitter[6]                = gunSmokeEmitter;
   stateEmitterTime[6]            = 0.5;
   stateEmitterNode[6]            = "muzzleNode";
   stateTimeoutValue[6]           = 0.076;
   stateTransitionOnTimeout[6]    = "Ready";

   stateName[7]                   = "Reload";
   stateTransitionOnNoAmmo[7]		= "ReloadWait";
   stateTransitionOnTriggerUp[7]  = "Smoke";
   stateTransitionOnTriggerDown[7]= "PrimeCheck";
   
   	stateName[10]					= "ReloadWait";
	stateTimeoutValue[10]			= 0.3;
	stateTransitionOnTimeout[10]	= "Ready";
	stateWaitForTimeout[10]			= true;
};

function Wolf3dChaingunImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
	//if (%obj.wolf3ddualwield || %obj.getClassName() $= "AIPlayer")
	//{
	//	%obj.mountImage(Wolf3dChainGunLeftHandImage, 1);
	//	%obj.playThread(1, armreadyboth);
	//}
}

function Wolf3dChaingunImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}

//Ephialtes' bullet spread coding
function Wolf3dChaingunImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		if (!$Pref::wolf3d::infiniteAmmo)
			%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, plant);

		%spread = 0.00175;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
	
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

//Check if the gun needs to reload. Use this to trigger state changes.
function Wolf3dChaingunImage::checkAmmo(%this,%obj,%slot)	
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}