////////////////
//FlameThrower//
////////////////

datablock AudioProfile(Wolf3dFlameThrowerSound)
{
   filename    = "./ft_fire.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("Wolf3dFlameThrowerKill", '<bitmap:Add-Ons/Weapon_Wolf3d/CI_Flamethrower> %1', '%2 <bitmap:Add-Ons/Weapon_Wolf3d/CI_Flamethrower> %1',0.2,1);

datablock ParticleData(Wolf3dFlameThrowerTrailParticle)
{
	dragCoefficient      = 2.9;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0. 0 0.1 1";
	colors[1]     = "1 0.5 0 0";
   	colors[2]     = "1 1 1 1";
   	colors[3]     = "1 0 0 0.5";

	sizes[0]      = 0.4;
	sizes[1]      = 0.8;
 	sizes[2]      = 1.2;
 	sizes[3]      = 1.6;

   	times[0] = 0;
   	times[1] = 1;
   	times[2] = 2;
  	times[3] = 2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(Wolf3dFlameThrowerTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = "Wolf3dFlameThrowerTrailParticle";
};

datablock ParticleData(Wolf3dFlameThrowerIdleParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 3.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";

	sizes[0]	= 0.0;
	sizes[1]	= 0.2;
	sizes[2]	= 0.15;

	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(Wolf3dFlameThrowerIdleEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0.5;
   ejectionVelocity = 1;
   ejectionOffset   = 0.00;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0.1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = Wolf3dFlameThrowerIdleParticle;   
};

datablock ExplosionData(Wolf3dFlameThrowerExplosion)
{
   //explosionShape = "";

   lifeTimeMS = 500;

   faceViewer     = true;

   particleEmitter = Wolf3dFlameThrowerTrailEmitter;
   explosionScale = "2 2 2";

   shakeCamera = false;

   // Dynamic light
   lightStartRadius = 0.5;
   lightEndRadius = 0.25;
   lightStartColor = "1 0.5 0 1";
   lightEndColor = "1 0.5 0 1";

   damageRadius = 3;
   radiusDamage = 1;

   playerBurnTime = 2500;
};

datablock ProjectileData(Wolf3dFlameThrowerProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::Wolf3dFlameThrowerKill;
   radiusDamageType    = $DamageType::Wolf3dFlameThrowerKill;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   explodeOnPlayerImpact = false;
   explodeondeath = true;
   
   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = Wolf3dFlameThrowerExplosion;
   particleEmitter     = Wolf3dFlameThrowerTrailEmitter;

   muzzleVelocity      = 25;
   velInheritFactor    = 0;

   armingDelay         = 1200;
   lifetime            = 1200;
   fadeDelay           = 1200;
   bounceElasticity    = 0.999;
   bounceFriction      = 0.0;
   isBallistic         = false;
   gravityMod = 0.25;
   
   ballRadius = 2;

   hasLight    = true;
   lightRadius = 1;
   lightColor  = "1 0.5 0 1";

   uiName = "Wolf3d Flamethrower";
};

datablock ItemData(Wolf3dFlameThrowerItem : GunItem)
{
   shapeFile       = "./flamethrower.dts";
   uiName          = "Wolf3d Flamethrower"; //We are going to add wolf3d so it does not conflict with other similarly named items.
   iconName        = "./Icon_Flamethrower";
   doColorShift    = false;
   colorShiftColor = "1 0.5 0 1";

   image   = Wolf3dFlameThrowerImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(Wolf3dFlameThrowerImage)
{
   // Basic Item properties
   shapeFile  = "./flamethrower.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.075 -0.5 -1";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dChaingunGunItem;
   ammo = "";
   projectile = Wolf3dFlameThrowerProjectile;
   projectileType = Projectile;

	casing 				= gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   
   doColorShift    = Wolf3dFlameThrowerItem.doColorShift;
   colorShiftColor = Wolf3dFlameThrowerItem.colorShiftColor;

	stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Prime";
	stateTransitionOnTimeout[1]       = "Ready";
	stateTimeoutValue[1]            = 0.07;
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";
   	stateEmitter[1]					= Wolf3dFlameThrowerIdleEmitter;
	stateEmitterTime[1]				= 0.07;
	stateEmitterNode[1]				= "muzzleNode";
	
	stateName[10]					= "Prime";
	stateScript[10]					= "checkAmmo";
	stateTimeoutValue[10]			= 0.005;
	stateTransitionOnTimeout[10]	= "PrimeCheck";
	
	stateName[11]					= "PrimeCheck";
	stateTransitionOnAmmo[11]		= "Fire";
	stateTransitionOnNoAmmo[11]		= "ReloadWait";
	
	stateName[12]					= "ReloadWait";
	stateTimeoutValue[12]			= 0.3;
	stateTransitionOnTimeout[12]	= "Ready";
	stateWaitForTimeout[12]			= true;

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Prime2Check";
   stateTimeoutValue[2]           = 0.085;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = Wolf3dFlameThrowerSound;
   stateEjectShell[2]             = false;
   
    //stateName[14]					= "Prime2";
	//stateScript[14]					= "checkAmmo";
	//stateTimeoutValue[14]			= 0.005;
	//stateTransitionOnTimeout[14]	= "Prime2Check";
	
	stateName[15]					= "Prime2Check";
	stateTransitionOnAmmo[15]		= "Fire2";
	stateTransitionOnNoAmmo[15]		= "ReloadWait";
   
   stateName[5]                   = "Fire2";
   stateTransitionOnTimeout[5]    = "Reload";
   stateTimeoutValue[5]           = 0.085;
   stateFire[5]                   = true;
   stateAllowImageChange[5]       = false;
   stateSequence[5]               = "Fire";
   stateScript[5]                 = "onFire";
   stateWaitForTimeout[5]         = true;
   stateEmitter[5]                = gunFlashEmitter;
   stateEmitterTime[5]            = 0.05;
   stateEmitterNode[5]            = "muzzleNode";
   stateSound[5]                  = Wolf3dFlameThrowerSound;
   stateEjectShell[5]             = false;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.5;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.057;
   stateTransitionOnTimeout[3]    = "Ready";

   stateName[4]                   = "Reload";
   stateTransitionOnNoAmmo[7]		= "ReloadWait";
   stateTransitionOnTriggerUp[4]  = "Smoke";
   stateTransitionOnTriggerDown[4]= "PrimeCheck";
   stateSequence[4]               = "Ready";
};

function Wolf3dFlameThrowerImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Fuel:  \c6" @  %obj.toolAmmo["wolf3d_fuel"] @ "", 4, 2, 3, 4); 
	}
	
}

//Ephialtes' bullet spread coding
function Wolf3dFlameThrowerImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
	
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_fuel"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		if (!$Pref::wolf3d::infiniteAmmo)
			%obj.toolAmmo["wolf3d_fuel"]--;

		%spread = 0.0005; //.1 = 180 degrees
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Fuel:  \c6" @  %obj.toolAmmo["wolf3d_fuel"] @ "", 4, 2, 3, 4); 
	}
	
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_fuel"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Wolf3dFlameThrowerProjectile::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
{
	if (%col.getClassName() $= "fxDTSBrick" || %col.getClassName() $= "fxPlane"){
		
		%obj.explode();
	}
		
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
}

function Wolf3dFlameThrowerProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%this.directDamage <= 0)
	  return;
	  
	//A rather weird setup so the flamethrower's piercing shots don't hit the same target more than once
	for (%i = 0; isObject(%target = %obj.hitTargets[%i]); %i++)
		if (%target.getID() == %col.getID())
			return;
	
	%obj.hitTargets[%i] = %col.getID();

	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
	  %damageType = %this.DirectDamageType;

	%scale = getWord(%obj.getScale(), 2);

	if (%obj.sourceObject.getClassName() $= "Player")
	{
		if (!$Pref::wolf3d::RandomDamage)
			%directDamage = 30;
		else
			%directDamage = getRandom(0,42);
	}
	else
	{
		if (!$Pref::wolf3d::RandomDamage)
			%directDamage = 25;
		else
			%directDamage = getRandom(0,32);
	}
   
	%scale = getWord(%obj.getScale(), 2);
	%directDamage = mClampF(%directDamage, -100.0, 100) * %scale;
   
	%col.damage(%obj, %pos, %directDamage, %damageType);
}
	//Check if the gun needs to reload. Use this to trigger state changes.
function Wolf3dFlamethrowerImage::checkAmmo(%this,%obj,%slot)
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_fuel"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}