//////////////
//Machinegun//
//////////////

datablock AudioProfile(Wolf3dMachineGunSound) 
{
   filename    = "./mg_fire.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("Wolf3dMachineGunKill", '<bitmap:Add-Ons/Weapon_Wolf3d/CI_MachineGun> %1', '%2 <bitmap:Add-Ons/Weapon_Wolf3d/CI_MachineGun> %1',0.2,1);

datablock ItemData(Wolf3dMachineGunItem : GunItem)
{
   shapeFile       = "./autorifle.dts";
   uiName          = "Wolf3d Machine Gun"; //We are going to add wolf3d so it does not conflict with other similarly named items.
   iconName        = "./Icon_MachineGun";
   doColorShift    = false;
   rotate = true;
   colorShiftColor = "1 1 1 1";
   
   isAmmo = true;
   ammoType = "ammo";
   ammoCount = 8;

   image   = Wolf3dMachineGunImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(Wolf3dMachineGunImage)
{
	// Basic Item properties
   shapeFile  = "./autorifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.02 1 -1.25"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dChaingunGunItem;
   ammo = "";
   projectile = Wolf3dGunProjectile;
   projectileType = Projectile;
   damageType	= $DamageType::Wolf3dMachineGunKill;

	casing 				= gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift    = Wolf3dMachineGunItem.doColorShift;
   colorShiftColor = Wolf3dMachineGunItem.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Prime";
   stateTimeoutValue[1]           = 0.057;
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";
   
   	stateName[10]					= "Prime";
	stateScript[10]					= "checkAmmo";
	stateTimeoutValue[10]			= 0.005;
	stateTransitionOnTimeout[10]	= "PrimeCheck";
	
	stateName[11]					= "PrimeCheck";
	stateTransitionOnAmmo[11]		= "Fire";
	stateTransitionOnNoAmmo[11]		= "ReloadWait";
	
	stateName[12]					= "ReloadWait";
	stateTimeoutValue[12]			= 0.3;
	stateTransitionOnTimeout[12]	= "Ready";
	stateWaitForTimeout[12]			= true;

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Reload";
   stateTimeoutValue[2]           = 0.16;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = Wolf3dMachineGunSound;
   stateEjectShell[2]             = true;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.25;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.086;
   stateTransitionOnTimeout[3]    = "Ready";

   stateName[4]                   = "Reload";
   stateSequence[4]               = "Reload";
   stateTransitionOnTriggerUp[4]  = "Smoke";
   stateTransitionOnTriggerDown[4]= "Prime";
   stateSequence[4]               = "Ready";
};

function Wolf3dMachineGunImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

//Ephialtes' bullet spread coding
function Wolf3dMachineGunImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		if (!$Pref::wolf3d::infiniteAmmo)
			%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, plant);

		%spread = 0.00076;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			initalPlayerPos = %obj.position;
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

function distance(%pa,%pb)
{
	%pointA[0] = -1;
	%pointA[1] = -1;
	%pointA[2] = -1;
	%pointB[0] = -1;
	%pointB[1] = -1;
	%pointB[2] = -1;
	
	for(%i=0;%i<3;%i++)
		%pointA[%i] = getWord(%pa,%i);
		
	for(%i=0;%i<3;%i++)
		%pointB[%i] = getWord(%pB,%i);
		
	%dist = mSqrt(mPow(%pointA[0] - %pointB[0],2) + mPow(%pointA[1] - %pointB[1],2) + mPow(%pointA[2] - %pointB[2],2));
	return mRound(%dist);
}

//Check if the gun needs to reload. Use this to trigger state changes.
function Wolf3dMachinegunImage::checkAmmo(%this,%obj,%slot)
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}