///////////
//RocketL//
///////////

datablock AudioProfile(Wolf3dRocketLSound)
{
   filename    = "./rl_fire.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("Wolf3dRocketLKill", '<bitmap:Add-Ons/Weapon_Wolf3d/CI_Bazooka> %1', '%2 <bitmap:Add-Ons/Weapon_Wolf3d/CI_Bazooka> %1',0.2,1);

//muzzle flash effects
datablock ParticleData(Wolf3dRocketLFlashParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 150;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.4 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.125;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Wolf3dRocketLFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Wolf3dRocketLFlashParticle";

   uiName = "Wolf3d Rocket Launcher Spark";
};

datablock ParticleData(Wolf3dRocketLSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 125;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.0125;
   sizes[1]      = 0.5;
	sizes[2]      = 0.875;

   times[0] = 0.0;
   times[1] = 0.25;
   times[2] = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Wolf3dRocketLSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Wolf3dRocketLSmokeParticle";

   uiName = "Wolf3d Rocket Launcher Smoke";
};


//bullet trail effects
datablock ParticleData(Wolf3dRocketLTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 5000;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.125;
	sizes[1]      = 0.425;
   sizes[2]      = 0.175;
 	sizes[3]      = 0.025;

   times[0] = 0.0;
   times[1] = 0.025;
   times[2] = 0.15;
   times[3] = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Wolf3dRocketLTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Wolf3dRocketLTrailParticle";

   uiName = "Wolf3d Rocket Trail";
};


datablock ParticleData(Wolf3dRocketLExplosionParticle)
{
	dragCoefficient      = 7;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 150;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 2.5;
	sizes[1]      = 5.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Wolf3dRocketLExplosionRingEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 7;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Wolf3dRocketLExplosionParticle";

   uiName = "Wolf3d Rocket Explosion Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(Wolf3dRocketLExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.2 0.5";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 4;
	sizes[1]      = 7;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Wolf3dRocketLExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Wolf3dRocketLExplosionRingParticle";

   uiName = "Wolf3d Rocket Explosion Flash";
};

datablock ExplosionData(Wolf3dRocketLExplosion)
{
   explosionShape = "";
   //explosionShape = "./explosionSphere1.dts";
	soundProfile = rocketExplodeSound;

   lifeTimeMS = 350;

   particleEmitter = Wolf3dRocketLExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.1;

   emitter[0] = Wolf3dRocketLExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "0.25 0.25 0.25";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.25;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 12;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 1";

   damageRadius = 2;
   radiusDamage = 50;

   impulseRadius = 2;
   impulseForce = 2000;
};

datablock ProjectileData(Wolf3dRocketLProjectile : gunProjectile)
{
   directDamage     = 100;
   directDamageType = $DamageType::Wolf3dRocketLKill;
   radiusDamageType = $DamageType::Wolf3dRocketLKill;
   impactImpulse    = 0;
   verticalImpulse  = 0;
   muzzleVelocity   = 100;
   velInheritFactor = 0;
   uiName           = "Wolf3d Rocket";
   
   projectileShapeName = "Add-Ons/Weapon_Rocket_Launcher/RocketProjectile.dts";
   explosion           = Wolf3dRocketLExplosion;
   particleEmitter     = Wolf3dRocketLTrailEmitter;

   brickExplosionRadius = 2;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;             
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = rocketLoopSound;

   muzzleVelocity      = 65;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 2.5;
   lightColor  = "1 0.5 0.0";

   uiName = "Wolf3d Rocket";
};

datablock ItemData(Wolf3dRocketLItem : GunItem)
{
   shapeFile       = "./rocketl.dts";
   uiName          = "Wolf3d Bazooka"; //We are going to add wolf3d so it does not conflict with other similarly named items.
   iconName        = "./Icon_Bazooka";
   doColorShift    = false;
   rotate = true;
   colorShiftColor = "1 1 0 1";

   image   = Wolf3dRocketLImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(Wolf3dRocketLImage)
{
   // Basic Item properties
   shapeFile  = "./rocketl.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0 0 -1.25";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dChaingunGunItem;
   ammo = "";
   projectile = Wolf3dRocketLProjectile;
   projectileType = Projectile;
   damageType = $DamageType::Wolf3dRocketLKill;

	casing 				= gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   
   doColorShift    = Wolf3dRocketLItem.doColorShift;
   colorShiftColor = Wolf3dRocketLItem.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Prime";
   stateTimeoutValue[1]           = 0.057;
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";
   
    stateName[10]					= "Prime";
	stateScript[10]					= "checkAmmo";
	stateTimeoutValue[10]			= 0.005;
	stateTransitionOnTimeout[10]	= "PrimeCheck";
	
	stateName[11]					= "PrimeCheck";
	stateTransitionOnAmmo[11]		= "Fire";
	stateTransitionOnNoAmmo[11]		= "ReloadWait";
	
	stateName[12]					= "ReloadWait";
	stateTimeoutValue[12]			= 0.3;
	stateTransitionOnTimeout[12]	= "Ready";
	stateWaitForTimeout[12]			= true;

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Smoke";
   stateTimeoutValue[2]           = 0.085;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = Wolf3dRocketLSound;
   stateEjectShell[2]             = false;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.5;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 1;
   stateTransitionOnTimeout[3]    = "Ready";
};

function Wolf3dRocketLImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Rocket:  \c6" @  %obj.toolAmmo["wolf3d_rocket"] @ "", 4, 2, 3, 4); 
	}
}

//Ephialtes' bullet spread coding
function Wolf3dRocketLImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
			
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_rocket"] > 0 || %obj.getClassName() $= "AIPlayer"){
	
		if (!$Pref::wolf3d::infiniteAmmo)
			%obj.toolAmmo["wolf3d_rocket"]--;
		
		%obj.playThread(2, shiftAway);

		%spread = 0.0;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Rocket:  \c6" @  %obj.toolAmmo["wolf3d_rocket"] @ "", 4, 2, 3, 4);
	}
}

function Wolf3dRocketLProjectile::onCollision(%this, %obj, %col)
{
	parent::onCollision(%this, %obj, %col);
	
	if ((%col.getClassName() $= "AIPlayer" || %col.getClassName() $= "Player") && %col.getState() $= "DEAD") //Bitwise typemask check does not work for some reason.
	{
		%p = new Projectile()
		{
			dataBlock = %obj.getDatablock();
			initialVelocity = %obj.initialVelocity;
			initialPosition = %obj.getPosition();
			sourceObject = %obj.sourceObject;
			sourceSlot = %obj.sourceSlot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
}

function Wolf3dRocketLProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%this.directDamage <= 0)
		return;

	//A rather weird setup so the rocket l's piercing shots don't hit the same target more than once
	for (%i = 0; isObject(%target = %obj.hitTargets[%i]); %i++)
		if (%target.getID() == %col.getID())
			return;
	
	%obj.hitTargets[%i] = %col.getID();
	
	%damageType = $DamageType::Direct;
	if(isObject(%obj.sourceObject) && %obj.sourceObject.getMountedImage(0).damageType)
		%damageType = %obj.sourceObject.getMountedImage(0).damageType;

	%dist = vectorDist(%obj.sourceObject.getPosition(),%col.getPosition());

	if (%obj.sourceObject.getClassName() $= "Player")
	{
		if (!$Pref::wolf3d::RandomDamage)
			%directDamage = 100;
		else
			%directDamage = getRandom(64,128);
	}
	else
	{
		if (!$Pref::wolf3d::RandomDamage)
			%directDamage = 48;
		else
			%directDamage = getRandom(32,64);
	}

	%col.damage(%obj, %pos, %directDamage, %damageType);
}

//Check if the gun needs to reload. Use this to trigger state changes.
function Wolf3dRocketLImage::checkAmmo(%this,%obj,%slot)
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_rocket"] <= 0) || %obj.getState() $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}