datablock AudioProfile(SoDBeamSound)
{
   filename    = "./SoDBeam.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(Wolf3dSoDTrailParticle : spearTrailParticle)
{
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 500;

	textureName		= "base/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.00 1.00 1.00 0.3";
	colors[1]	= "0.00 1.00 1.00 0.7";
	colors[2]	= "1.00 1.00 1.00 0.2";
	sizes[0]	= 0.15;
	sizes[1]	= 0.35;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(Wolf3dSoDTrailEmitter : spearTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Wolf3dSoDTrailParticle;

   useEmitterColors = true;
   uiName = "SoD Trail";
};


//effects
datablock ParticleData(spearExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.3 0.3 0.2 0.9";
	colors[1]	= "0.2 0.2 0.2 0.0";
	sizes[0]	= 4.0;
	sizes[1]	= 7.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(spearExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spearExplosionParticle";

   uiName = "Spear Smoke";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(spearExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/chunk";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.0 0.0 0.0 1.0";
	colors[1]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 0.5;
	sizes[1]	= 0.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(spearExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 7;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spearExplosionParticle2";

   useEmitterColors = true;
   uiName = "Spear Chunk";
   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(Wolf3dSoDExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = spearExplosionSound;

   emitter[0] = spearExplosionEmitter;
   emitter[1] = spearExplosionEmitter2;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 3.5;
   impulseForce = 4000;

   //radius damage
   radiusDamage        = 40;
   damageRadius        = 3.5;
};

//projectile
AddDamageType("SoDDirect",   'Spear of Destiny %1',       '%2 Spear of Destiny %1',1,1);
AddDamageType("SoDRadius",   '( Spear of Destiny ) %1', '%2 ( Spear of Destiny ) %1',1,0);
datablock ProjectileData(Wolf3dSoDProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Wolf3d/SoDProjectile.dts";
   directDamage        = 90;
   directDamageType  = $DamageType::SpearDirect;
   radiusDamageType  = $DamageType::SpearRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 0;
   explosion           = spearExplosion;
   particleEmitter     = Wolf3dSoDTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 200;
   brickExplosionMaxVolumeFloating = 200;
   
   sound = SoDBeamSound;

   explodeOnPlayerImpact = true;
   explodeondeath = false;
   
   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 2000;
   lifetime            = 2000;
   fadeDelay           = 1950;
   bounceElasticity    = 0.999;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.25;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 1 1";

   uiName = "SoD Beam";
};

datablock ItemData(Wolf3dSoDItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SoD.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Spear of Destiny";
	//iconName = "./icon_sword";
	doColorShift = true;
	colorShiftColor = "1.000 1.000 0.000 1.000";

	 // Dynamic properties defined by the scripts
	image = Wolf3dSoDImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Wolf3dSoDImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Wolf3d/SoD.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = 0;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dSoDItem;
   ammo = " ";
   projectile = swordProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1.000 1.000 0.000 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Charge";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]			= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
	
	stateName[6]                    = "Charge";
	stateTransitionOnTimeout[6]	= "Armed";
	stateTimeoutValue[6]            = 0.7;
	stateWaitForTimeout[6]		= false;
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateScript[6]                  = "onCharge";
	stateAllowImageChange[6]        = false;

	stateName[7]			= "Armed";
	stateTransitionOnTriggerUp[7]	= "FireSpear";
	stateAllowImageChange[7]	= false;

	stateName[8]			= "FireSpear";
	stateTransitionOnTimeout[8]	= "Ready";
	stateTimeoutValue[8]		= 0.5;
	stateFire[8]			= true;
	stateSequence[8]		= "fire";
	stateScript[8]			= "onSpearFire";
	stateWaitForTimeout[8]		= true;
	stateAllowImageChange[8]	= false;
	stateSound[8]				= spearFireSound;


};

function Wolf3dSoDImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function Wolf3dSoDImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function Wolf3dSoDImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function Wolf3dSoDImage::onSpearFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	
	%spread = 0.000115;
	%projectile = %this.projectile;
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	if (%obj.getClassName() $= "AIPlayer")
		%spread *= $wolf3d::botAccuracy;
			
	%p = new (%this.projectileType)()
	{
		dataBlock = Wolf3dSoDProjectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		directDamage = (getRandom(0,42));
	};
	MissionCleanup.add(%p);
}

function Wolf3dSoDProjectile::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
{
	if (%col.getClassName() $= "fxDTSBrick" || %col.getClassName() $= "fxPlane"){
		
		%obj.schedule(1000,"explode");
	}
		
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
}