///////////
//Walther//
///////////

datablock AudioProfile(Wolf3dPistolGunSound)
{
   filename    = "./pi_fire.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("Wolf3dPistolGunKill", '<bitmap:Add-Ons/Weapon_Wolf3d/CI_Pistol> %1', '%2 <bitmap:Add-Ons/Weapon_Wolf3d/CI_Pistol> %1',0.2,1);

datablock ProjectileData(Wolf3dGunProjectile : gunProjectile)
{
   directDamage     = 32;
   impactImpulse    = 0;
   verticalImpulse  = 0;
   muzzleVelocity   = 200;
   velInheritFactor = 0;
   uiName           = "Wolf3d Bullet";
};

datablock ItemData(Wolf3dPistolGunItem : GunItem)
{
   shapeFile       = "./luger.dts";
   uiName          = "Wolf3d Pistol"; //We are going to add wolf3d so it does not conflict with other similarly named items.
   iconName        = "./Icon_Pistol";
   doColorShift    = false;
   rotate = true;
   colorShiftColor = "0.5 0.5 0.5 1";

   image   = Wolf3dPistolGunImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(Wolf3dPistolGunImage) //We could inherit the gun to decrease the db size, but that will mess up the states.
{
   // Basic Item properties
   shapeFile = "./luger.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0 1.35 -1.325"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Wolf3dPistolGunItem;
   ammo = "";
   projectile = Wolf3dGunProjectile;
   projectileType = Projectile;
   damageType = $DamageType::Wolf3dPistolGunKill;

	casing 				= gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift    = Wolf3dPistolGunItem.doColorShift;
   colorShiftColor = Wolf3dPistolGunItem.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Prime";
   stateTimeoutValue[1]           = 0.057;
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";
   
   	stateName[10]					= "Prime";
	stateScript[10]					= "checkAmmo";
	stateTimeoutValue[10]			= 0.005;
	stateTransitionOnTimeout[10]	= "PrimeCheck";
	
	stateName[11]					= "PrimeCheck";
	stateTransitionOnAmmo[11]		= "Fire";
	stateTransitionOnNoAmmo[11]		= "ReloadWait";
	
	stateName[12]					= "ReloadWait";
	stateTimeoutValue[12]			= 0.3;
	stateTransitionOnTimeout[12]	= "Ready";
	stateWaitForTimeout[12]			= true;

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Smoke";
   stateTimeoutValue[2]           = 0.085;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = Wolf3dPistolGunSound;
   stateEjectShell[2]             = true;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.125;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.086;
   stateTransitionOnTimeout[3]    = "Reload";
	  
   stateName[4]					  = "Reload";
   stateSequence[4]				  = "Reload";
   stateTransitionOnTriggerUp[4]  = "Ready";
   stateSequence[4]				  = "Ready";
};

function Wolf3dPistolGunImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

//Ephialtes' bullet spread coding
function Wolf3dPistolGunImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
			
	if (isObject(%image = %obj.getMountedImage(1)) && %image.wolf3d_lefthand && %obj.getImageState(0) $= "Fire")
		%obj.setImageTrigger(1,1);
		
	if ($Pref::wolf3d::infiniteAmmo || %obj.toolAmmo["wolf3d_ammo"] > 0 || %obj.getClassName() $= "AIPlayer"){
		if (!$Pref::wolf3d::infiniteAmmo)
			%obj.toolAmmo["wolf3d_ammo"]--;
		
		%obj.playThread(2, shiftAway);

		%spread = 0.000115;
		%projectile = %this.projectile;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		if (%obj.getClassName() $= "AIPlayer")
			%spread /= $Pref::wolf3d::botAccuracy;
			
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			directDamage = (getRandom(0,42));
		};
		MissionCleanup.add(%p);
	}
	
	if (!$Pref::wolf3d::infiniteAmmo)
	{
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
		else commandToClient(%obj.client,'bottomPrint',"<just:center><font:impact:24><color:00FBFF>Ammo:  \c6" @  %obj.toolAmmo["wolf3d_ammo"] @ "", 4, 2, 3, 4); 
	}
}

function Wolf3dGunProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%this.directDamage <= 0)
		return;

	%damageType = $DamageType::Direct;
	if(isObject(%obj.sourceObject) && %obj.sourceObject.getMountedImage(0).damageType)
	  %damageType = %obj.sourceObject.getMountedImage(0).damageType;

	%dist = vectorDist(%obj.sourceObject.getPosition(),%col.getPosition());
	if (%obj.sourceObject.getClassName() $= "Player")
	{
		if (!$Pref::wolf3d::RandomDamage)
		{
			if (%dist < 16)
				%directDamage = 32;
			else
				%directDamage = 28;
		}
		else
		{
			if (%dist < 16)
				%directDamage = getRandom(0,64);
			else
				%directDamage = getRandom(0,42);
		}
		
	}
	else
	{
		if (!$Pref::wolf3d::RandomDamage)
		{
			if (%dist < 8)
			%directDamage = 32;
			else if (%dist <= 16)
				%directDamage = 24;
			else
				%directDamage = 18;
		}
		else
		{
			if (%dist < 8)
			%directDamage = getRandom(0,64);
			else if (%dist <= 16)
				%directDamage = getRandom(0,32);
			else
				%directDamage = getRandom(0,16);
		}
	}
	
	%scale = getWord(%obj.getScale(), 2);
	%directDamage = mClampF(%directDamage, -100.0, 100) * %scale;

	%col.damage(%obj, %pos, %directDamage, %damageType);
}

//Check if the gun needs to reload. Use this to trigger state changes.
function Wolf3dPistolGunImage::checkAmmo(%this,%obj,%slot)
{
	if ((!$Pref::wolf3d::infiniteAmmo && %obj.getClassName() $= "Player" && %obj.toolAmmo["wolf3d_ammo"] <= 0) || strUpr(%obj.getState()) $= "DEAD")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}