%error = ForceRequiredAddOn("Weapon_Gun");
%error2 = ForceRequiredAddOn("Weapon_Rocket_Launcher");

if(%error == $Error::AddOn_Disabled || %error2 == $Error::AddOn_Disabled)
{
   error("ERROR: Weapon_Wolf3d - Add-Ons Weapon_Gun and Weapon_Rocket_Launcher required.");
   return;
}

//////
//Welcome to the code!
//////

function Wolf3d_RegisterPrefs()
{
	if ($RTB::Hooks::ServerControl)
	{
		RTB_registerPref("Load Weapons (Requires Restart)", "Wolf3d - Weapons", "$Pref::wolf3d::loadWeapons", "bool", "Weapon_Wolf3d", true, false, false, "");
		RTB_registerPref("Random Damage", "Wolf3d - Weapons", "$Pref::wolf3d::RandomDamage", "bool", "Weapon_Wolf3d", false, false, false, "");
		RTB_registerPref("Bot Accuracy Multiplier", "Wolf3d - Weapons", "$Pref::wolf3d::botAccuracy", "double 0.1 2.0", "Weapon_Wolf3d", 0.5, false, false, "");
		RTB_registerPref("Show All Ammo Types", "Wolf3d - Weapons", "$Pref::wolf3d::printAllAmmo", "bool", "Weapon_Wolf3d", false, false, false, "");
		RTB_registerPref("Infinite Ammo", "Wolf3d - Weapons", "$Pref::wolf3d::infiniteAmmo", "bool", "Weapon_Wolf3d", false, false, false, "");
		RTB_registerPref("Starting Bullets", "Wolf3d - Weapons", "$Pref::wolf3d::startingAmmo", "int 0 99", "Weapon_Wolf3d", 8, false, false, "");
		RTB_registerPref("Starting Fuel", "Wolf3d - Weapons", "$Pref::wolf3d::startingFuel", "int 0 99", "Weapon_Wolf3d", 14, false, false, "");
		RTB_registerPref("Starting Rockets", "Wolf3d - Weapons", "$Pref::wolf3d::startingRockets", "int 0 99", "Weapon_Wolf3d", 5, false, false, "");
		
		RTB_registerPref("Load Score Pickups (Requires Restart)", "Wolf3d - Score", "$Pref::wolf3d::loadScorePickups", "bool", "Weapon_Wolf3d", true, false, false, "");
		RTB_registerPref("Cross Score", "Wolf3d - Score", "$Pref::wolf3d::score_Cross", "int 0 99999", "Weapon_Wolf3d", 1, false, false, "");
		RTB_registerPref("Chalice Score", "Wolf3d - Score", "$Pref::wolf3d::score_Chalice", "int 0 99999", "Weapon_Wolf3d", 5, false, false, "");
		RTB_registerPref("Chest Score", "Wolf3d - Score", "$Pref::wolf3d::score_Chest", "int 0 99999", "Weapon_Wolf3d", 10, false, false, "");
		RTB_registerPref("Crown Score", "Wolf3d - Score", "$Pref::wolf3d::score_Crown", "int 0 99999", "Weapon_Wolf3d", 50, false, false, "");
		
		RTB_registerPref("Load Health Pickups (Requires Restart)", "Wolf3d - Health", "$Pref::wolf3d::loadHealthPickups", "bool", "Weapon_Wolf3d", true, false, false, "");
		RTB_registerPref("Dog Food Healing", "Wolf3d - Health", "$Pref::wolf3d::health_Dog", "int 0 99999", "Weapon_Wolf3d", 4, false, false, "");
		RTB_registerPref("Food Plate Healing", "Wolf3d - Health", "$Pref::wolf3d::health_Food", "int 0 99999", "Weapon_Wolf3d", 10, false, false, "");
		RTB_registerPref("Medkit Healing", "Wolf3d - Health", "$Pref::wolf3d::health_Medkit", "int 0 99999", "Weapon_Wolf3d", 25, false, false, "");
		RTB_registerPref("One Up Healing", "Wolf3d - Health", "$Pref::wolf3d::health_OneUp", "int 0 99999", "Weapon_Wolf3d", 100, false, false, "");
	}
	else
	{	
		if ($Pref::wolf3d::loadWeapons $= "") $Pref::wolf3d::loadWeapons = true;
		if ($Pref::wolf3d::RandomDamage $= "") $wolf3d::RandomDamage = false;
		if ($Pref::wolf3d::botAccuracy $= "") $Pref::wolf3d::botAccuracy = 0.5;
		if ($Pref::wolf3d::printAllAmmo $= "") $Pref::wolf3d::printAllAmmo = false;
		if ($Pref::wolf3d::infiniteAmmo $= "") $Pref::wolf3d::infiniteAmmo = false;
		if ($Pref::wolf3d::startingAmmo $= "") $Pref::wolf3d::startingAmmo = 8;
		if ($Pref::wolf3d::startingFuel $= "") $Pref::wolf3d::startingFuel = 14;
		if ($Pref::wolf3d::startingRockets $= "") $Pref::wolf3d::startingRockets = 5;
		
		if ($Pref::wolf3d::loadScorePickups $= "") $Pref::wolf3d::loadScorePickups = true;
		if ($Pref::wolf3d::score_Cross $= "") $Pref::wolf3d::score_Cross = 1;
		if ($Pref::wolf3d::score_Chalice $= "") $Pref::wolf3d::score_Chalice = 5;
		if ($Pref::wolf3d::score_Chest $= "") $Pref::wolf3d::score_Chest = 10;
		if ($Pref::wolf3d::score_Crown $= "") $Pref::wolf3d::score_Crown = 50;
		
		if ($Pref::wolf3d::loadHealthPickups $= "") $Pref::wolf3d::loadHealthPickups = true;
		if ($Pref::wolf3d::health_Dog $= "") $Pref::wolf3d::health_Dog = 4;
		if ($Pref::wolf3d::health_Food $= "") $Pref::wolf3d::health_Food = 10;
		if ($Pref::wolf3d::health_Medkit $= "") $Pref::wolf3d::health_Medkit = 25;
		if ($Pref::wolf3d::health_OneUp $= "") $Pref::wolf3d::health_OneUp = 100;
	}
}
Wolf3d_RegisterPrefs();


function Wolf3d_AmmoOnSpawn(%this,%obj)
{
   %obj.toolAmmo["wolf3d_ammo"] = $Pref::wolf3d::startingAmmo + 0;
   %obj.toolAmmo["wolf3d_fuel"] = $Pref::wolf3d::startingFuel + 0;
   %obj.toolAmmo["wolf3d_rocket"] = $Pref::wolf3d::startingRockets + 0;
}

function Wolf3dDisplayAllAmmo(%cl)
{
	if (!isObject(%cl.player)) return;
	%pl = %cl.player;
	%base 	= "<just:right><font:impact:24><color:00FBFF>";
	%ammo 	= "Ammo:  \c6" @ %pl.toolAmmo["wolf3d_ammo"];
	%fuel 	= "<br>Fuel:  \c6" @ %pl.toolAmmo["wolf3d_fuel"];
	%rocket = "<br>Rocket:  \c6" @ %pl.toolAmmo["wolf3d_rocket"];
	%health = "<br>\c0Health:  \c6" @ %pl.getHealth();
	%cl.bottomPrint(%base @ %ammo @ %fuel @ %rocket @ %health,10,1);
}

package Wolf3d_Main
{
	function armor::onadd(%this,%obj) //Based off of T+T's weapon system.
	{
		Parent::onadd(%this,%obj);
		Wolf3d_AmmoOnSpawn(%this,%obj);
	}
	function Armor::damage(%this, %obj, %sourceObj, %position, %damage, %damageType)
	{
		Parent::damage(%this, %obj, %sourceObj, %position, %damage, %damageType);
		if (%obj.getClassName() $= "Player" && $Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
	}
	function Player::addHealth(%obj,%health)
	{
		parent::addHealth(%obj,%health);
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
	}
	function Player::setHealth(%obj,%health)
	{
		parent::setHealth(%obj,%health);
		if ($Pref::wolf3d::printAllAmmo) Wolf3dDisplayAllAmmo(%obj.client);
	}
};
activatePackage(Wolf3d_Main);

if ($Pref::wolf3d::loadWeapons)
{
	exec("./Item_Ammo.cs");
	exec("./Weapon_Walther.cs");
	exec("./Weapon_Machinegun.cs");
	exec("./Weapon_Chaingun.cs");
	exec("./Weapon_Flamethrower.cs");
	exec("./Weapon_RocketL.cs");
	
	//exec("./Support_DualWield.cs");
	
	//exec("./Weapon_SoD.cs");
}

if ($Pref::wolf3d::loadHealthPickups)
	exec("./Item_Health.cs");
if ($Pref::wolf3d::loadScorePickups)
	exec("./Item_Score.cs");